package common;

import java.rmi.Remote;
import java.rmi.RemoteException;
import java.util.Vector;

import domain.Account;
import domain.Owner;
import domain.RuralHouse;

public interface AdminInterface extends Remote {

	
	public Vector<RuralHouse> getAdditionRequests() throws RemoteException;

	public Vector<RuralHouse> getDeletionRequests() throws RemoteException ;

	public Vector<Account> getOwnerAdditionRequests() throws RemoteException ;
	
	public void removeHouseAdditionRequests(RuralHouse house) throws RemoteException ;

	public void removeHouseDeletionRequests(RuralHouse house) throws RemoteException ;
	
	public void removeOwnerAdditionRequests(int index) throws RemoteException ;
	
	public boolean addAdditionRequest(RuralHouse rh) throws RemoteException ;

	public boolean addDeletionRequest(RuralHouse rh) throws RemoteException ;
	
	public boolean addAccountRequest(String usr,
			String pss, Owner ow) throws RemoteException;
	
	public void saveInstance() throws RemoteException;
	
	
}
